/*
 * This file is generated by jOOQ.
 */
package de.ship.clip.db.tables;


import de.ship.clip.db.Config;
import de.ship.clip.db.Keys;
import de.ship.clip.db.tables.records.TMenuitemRecord;

import java.util.Arrays;
import java.util.List;
import java.util.function.Function;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Function8;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Records;
import org.jooq.Row8;
import org.jooq.Schema;
import org.jooq.SelectField;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TMenuitem extends TableImpl<TMenuitemRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>config.t_menuitem</code>
     */
    public static final TMenuitem T_MENUITEM = new TMenuitem();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TMenuitemRecord> getRecordType() {
        return TMenuitemRecord.class;
    }

    /**
     * The column <code>config.t_menuitem.pk</code>.
     */
    public final TableField<TMenuitemRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>config.t_menuitem.url</code>.
     */
    public final TableField<TMenuitemRecord, String> URL = createField(DSL.name("url"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>config.t_menuitem.fk_label</code>.
     */
    public final TableField<TMenuitemRecord, Integer> FK_LABEL = createField(DSL.name("fk_label"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>config.t_menuitem.fk_description</code>.
     */
    public final TableField<TMenuitemRecord, Integer> FK_DESCRIPTION = createField(DSL.name("fk_description"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>config.t_menuitem.app_id</code>.
     */
    public final TableField<TMenuitemRecord, String> APP_ID = createField(DSL.name("app_id"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>config.t_menuitem.icon_url</code>.
     */
    public final TableField<TMenuitemRecord, String> ICON_URL = createField(DSL.name("icon_url"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>config.t_menuitem.order_nr</code>.
     */
    public final TableField<TMenuitemRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>config.t_menuitem.keycloak_role</code>.
     */
    public final TableField<TMenuitemRecord, String> KEYCLOAK_ROLE = createField(DSL.name("keycloak_role"), SQLDataType.CLOB, this, "");

    private TMenuitem(Name alias, Table<TMenuitemRecord> aliased) {
        this(alias, aliased, null);
    }

    private TMenuitem(Name alias, Table<TMenuitemRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>config.t_menuitem</code> table reference
     */
    public TMenuitem(String alias) {
        this(DSL.name(alias), T_MENUITEM);
    }

    /**
     * Create an aliased <code>config.t_menuitem</code> table reference
     */
    public TMenuitem(Name alias) {
        this(alias, T_MENUITEM);
    }

    /**
     * Create a <code>config.t_menuitem</code> table reference
     */
    public TMenuitem() {
        this(DSL.name("t_menuitem"), null);
    }

    public <O extends Record> TMenuitem(Table<O> child, ForeignKey<O, TMenuitemRecord> key) {
        super(child, key, T_MENUITEM);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Config.CONFIG;
    }

    @Override
    public Identity<TMenuitemRecord, Integer> getIdentity() {
        return (Identity<TMenuitemRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TMenuitemRecord> getPrimaryKey() {
        return Keys.T_MENUITEM_PKEY;
    }

    @Override
    public List<UniqueKey<TMenuitemRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.T_MENUITEM_URL_KEY, Keys.T_MENUITEM_APP_ID_KEY);
    }

    @Override
    public List<ForeignKey<TMenuitemRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_MENUITEM__T_MENUITEM_FK_LABEL_FKEY, Keys.T_MENUITEM__T_MENUITEM_FK_DESCRIPTION_FKEY);
    }

    private transient TDisplaylabel _tMenuitemFkLabelFkey;
    private transient TDisplaylabel _tMenuitemFkDescriptionFkey;

    /**
     * Get the implicit join path to the <code>config.t_displaylabel</code>
     * table, via the <code>t_menuitem_fk_label_fkey</code> key.
     */
    public TDisplaylabel tMenuitemFkLabelFkey() {
        if (_tMenuitemFkLabelFkey == null)
            _tMenuitemFkLabelFkey = new TDisplaylabel(this, Keys.T_MENUITEM__T_MENUITEM_FK_LABEL_FKEY);

        return _tMenuitemFkLabelFkey;
    }

    /**
     * Get the implicit join path to the <code>config.t_displaylabel</code>
     * table, via the <code>t_menuitem_fk_description_fkey</code> key.
     */
    public TDisplaylabel tMenuitemFkDescriptionFkey() {
        if (_tMenuitemFkDescriptionFkey == null)
            _tMenuitemFkDescriptionFkey = new TDisplaylabel(this, Keys.T_MENUITEM__T_MENUITEM_FK_DESCRIPTION_FKEY);

        return _tMenuitemFkDescriptionFkey;
    }

    @Override
    public TMenuitem as(String alias) {
        return new TMenuitem(DSL.name(alias), this);
    }

    @Override
    public TMenuitem as(Name alias) {
        return new TMenuitem(alias, this);
    }

    @Override
    public TMenuitem as(Table<?> alias) {
        return new TMenuitem(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TMenuitem rename(String name) {
        return new TMenuitem(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TMenuitem rename(Name name) {
        return new TMenuitem(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TMenuitem rename(Table<?> name) {
        return new TMenuitem(name.getQualifiedName(), null);
    }

    // -------------------------------------------------------------------------
    // Row8 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row8<Integer, String, Integer, Integer, String, String, Integer, String> fieldsRow() {
        return (Row8) super.fieldsRow();
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Function)}.
     */
    public <U> SelectField<U> mapping(Function8<? super Integer, ? super String, ? super Integer, ? super Integer, ? super String, ? super String, ? super Integer, ? super String, ? extends U> from) {
        return convertFrom(Records.mapping(from));
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Class,
     * Function)}.
     */
    public <U> SelectField<U> mapping(Class<U> toType, Function8<? super Integer, ? super String, ? super Integer, ? super Integer, ? super String, ? super String, ? super Integer, ? super String, ? extends U> from) {
        return convertFrom(toType, Records.mapping(from));
    }
}
